package jfd.exp;

import java.util.Hashtable;
import java.util.Enumeration;

public class SymbolTable
{
   private static final int KEY   = 0;
   private static final int VALUE = 1;

   private static Object usefulConstants[][] =
   {
      { "M_E",           new Double(2.7182818284590452354),  },
      { "M_LOG2E",       new Double(1.4426950408889634074),  },
      { "M_LOG10E",      new Double(0.43429448190325182765), },
      { "M_LN2",         new Double(0.69314718055994530942), },
      { "M_LN10",        new Double(2.30258509299404568402), },
      { "M_PI",          new Double(3.14159265358979323846), },
      { "M_PI_2",        new Double(1.57079632679489661923), },
      { "M_PI_4",        new Double(0.78539816339744830962), },
      { "M_1_PI",        new Double(0.31830988618379067154), },
      { "M_2_PI",        new Double(0.63661977236758134308), },
      { "M_2_SQRTPI",    new Double(1.12837916709551257390), },
      { "M_SQRT2",       new Double(1.41421356237309504880), },
      { "M_SQRT1_2",     new Double(0.707106781186),         },
   };

   private Hashtable table = null;

   public SymbolTable(boolean addUsefulConstants)
   {
      table = new Hashtable();

      if(addUsefulConstants)
      {
         for(int i = 0; i < usefulConstants.length; i ++)
         {
            String key   = (String)usefulConstants[i][KEY];
            double value = ((Double)usefulConstants[i][VALUE]).doubleValue();

            setValue(key, value);
         }
      }
   }

   public SymbolTable()
   {
      this(false);
   }

   public void setValue(String key, double value)
   {
      table.put(key.toLowerCase(), new Double(value));
   }

   public double getValue(String key) throws Exception
   {
      Double d = (Double)table.get(key.toLowerCase());

      if(d == null)
      {
         throw new Exception(
            "Undefined variable: [" + key + "]"
         );
      }

      return(d.doubleValue());
   }

   public void print()
   {
      Enumeration e = table.keys();

      while(e.hasMoreElements())
      {
         String key = (String)e.nextElement();

         try
         {
            System.out.println("[" + key + "] => [" + getValue(key) + "]");
         }
         catch(Exception impossible) {}
      }
   }
}
